﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ColumnChart
{
    public partial class MainWindow : Window
    {
        private List<DataItem> _data;
        public MainWindow()
        {
            InitializeComponent();
        }
        public List<DataItem> Data
        {
            get
            {
                if (_data == null)
                {
                    _data = new List<DataItem>();
                    _data.Add(new DataItem("UK", 5, 4));
                    _data.Add(new DataItem("USA", 7, 3));
                    _data.Add(new DataItem("Germany", 8, 5));
                    _data.Add(new DataItem("Japan", 12, 8));
                }

                return _data;
            }
        }
        private void chart_Rendered(object sender, C1.WPF.Chart.RenderEventArgs e)
        {
            // find render canvas
            var cnv = chart.FindFirstChild<C1.WPF.Chart.RenderCanvas>();
            foreach (var item in cnv.Children)
            {
                var rect = item as System.Windows.Shapes.Rectangle;
                if (rect != null)
                {
                    // move to the front
                    Canvas.SetZIndex(rect, 1);
                    //Use opaque fill
                    rect.Fill = rect.Stroke;
                }
            }
        }
    }

    public class DataItem
    {
        public DataItem(string country, int sales, int expenses)
        {
            Country = country;
            Sales = sales;
            Expenses = expenses;
        }

        public string Country { get; set; }
        public int Sales { get; set; }
        public int Expenses { get; set; }
    }

    public static class Extension
    {
        internal static T FindFirstChild<T>(this UIElement parent) where T : DependencyObject
        {
            T item = null;
            if (parent != null)
            {
                int cnt = VisualTreeHelper.GetChildrenCount(parent);
                for (int i = 0; i < cnt; i++)
                {
                    var child = VisualTreeHelper.GetChild(parent, i);
                    if (child is T)
                        return (T)child;
                    else
                    {
                        var ue = child as UIElement;
                        if (ue != null)
                            item = ue.FindFirstChild<T>();
                        if (item != null)
                            break;
                    }
                }
            }

            return item;
        }
    }
}
